diff --git a/examples/c/31_save_to_file/src/main.c b/examples/c/31_save_to_file/src/main.c
index 685c093b0..f3b006492 100644
--- a/examples/c/31_save_to_file/src/main.c
+++ b/examples/c/31_save_to_file/src/main.c
@@ -30,16 +30,16 @@ void save_to_file(
     const char *filename)
 {
     ecs_reader_t reader = ecs_reader_init(world);
-    FILE *savegame = fopen(filename, "wb");
+    FILE *file = fopen(filename, "wb");
 
     /* Read data from flecs in BUFFER_SIZE chunks */
     char buffer[BUFFER_SIZE];
     size_t read;
     while ((read = ecs_reader_read(buffer, BUFFER_SIZE, &reader))) {
-        fwrite(buffer, 1, read, savegame);
+        fwrite(buffer, 1, read, file);
     }
 
-    fclose(savegame);
+    fclose(file);
 }
 
 void load_from_file(
@@ -47,19 +47,19 @@ void load_from_file(
     const char *filename)
 {
     ecs_writer_t writer = ecs_writer_init(world);
-    FILE* savegame = fopen(filename, "r");
+    FILE* file = fopen(filename, "r");
 
     /* Write data to flecs in BUFFER_SIZE chunks */
     char buffer[BUFFER_SIZE];
     size_t read;    
-    while ((read = fread(buffer, 1, BUFFER_SIZE, savegame))) {
+    while ((read = fread(buffer, 1, BUFFER_SIZE, file))) {
         if (ecs_writer_write(buffer, read, &writer)) {
             printf("error: %s\n", ecs_strerror(writer.error));
             break;
         }
     }
 
-    fclose(savegame);
+    fclose(file);
 }
 
 int main(int argc, char *argv[]) {
@@ -85,7 +85,7 @@ int main(int argc, char *argv[]) {
     load_from_file(world, FILENAME);
 
     /* Note that components don't have to be redefined, they are restored by the
-     * writer in the load_from_file function. */
+     * writer. */
 
     /* Create and run a system on the loaded data */
     ECS_SYSTEM(world, Move, EcsOnUpdate, Position, Velocity);
diff --git a/examples/cpp/31_save_to_file/.gitignore b/examples/cpp/31_save_to_file/.gitignore
new file mode 100644
index 000000000..fff6aadd6
--- /dev/null
+++ b/examples/cpp/31_save_to_file/.gitignore
@@ -0,0 +1,5 @@
+.bake_cache
+.DS_Store
+.vscode
+gcov
+bin
diff --git a/examples/cpp/31_save_to_file/include/save_to_file.h b/examples/cpp/31_save_to_file/include/save_to_file.h
new file mode 100644
index 000000000..155e9df6e
--- /dev/null
+++ b/examples/cpp/31_save_to_file/include/save_to_file.h
@@ -0,0 +1,16 @@
+#ifndef SAVE_TO_FILE_H
+#define SAVE_TO_FILE_H
+
+/* This generated file contains includes for project dependencies */
+#include "save_to_file/bake_config.h"
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif
+
diff --git a/examples/cpp/31_save_to_file/include/save_to_file/bake_config.h b/examples/cpp/31_save_to_file/include/save_to_file/bake_config.h
new file mode 100644
index 000000000..9e65739bd
--- /dev/null
+++ b/examples/cpp/31_save_to_file/include/save_to_file/bake_config.h
@@ -0,0 +1,44 @@
+/*
+                                   )
+                                  (.)
+                                  .|.
+                                  | |
+                              _.--| |--._
+                           .-';  ;`-'& ; `&.
+                          \   &  ;    &   &_/
+                           |"""---...---"""|
+                           \ | | | | | | | /
+                            `---.|.|.|.---'
+
+ * This file is generated by bake.lang.c for your convenience. Headers of
+ * dependencies will automatically show up in this file. Include bake_config.h
+ * in your main project file. Do not edit! */
+
+#ifndef SAVE_TO_FILE_BAKE_CONFIG_H
+#define SAVE_TO_FILE_BAKE_CONFIG_H
+
+/* Headers of public dependencies */
+#include <flecs.h>
+
+/* Headers of private dependencies */
+#ifdef SAVE_TO_FILE_IMPL
+/* No dependencies */
+#endif
+
+/* Convenience macro for exporting symbols */
+#ifndef SAVE_TO_FILE_STATIC
+  #if SAVE_TO_FILE_IMPL && (defined(_MSC_VER) || defined(__MINGW32__))
+    #define SAVE_TO_FILE_EXPORT __declspec(dllexport)
+  #elif SAVE_TO_FILE_IMPL
+    #define SAVE_TO_FILE_EXPORT __attribute__((__visibility__("default")))
+  #elif defined _MSC_VER
+    #define SAVE_TO_FILE_EXPORT __declspec(dllimport)
+  #else
+    #define SAVE_TO_FILE_EXPORT
+  #endif
+#else
+  #define SAVE_TO_FILE_EXPORT
+#endif
+
+#endif
+
diff --git a/examples/cpp/31_save_to_file/project.json b/examples/cpp/31_save_to_file/project.json
new file mode 100644
index 000000000..cf3babc7b
--- /dev/null
+++ b/examples/cpp/31_save_to_file/project.json
@@ -0,0 +1,12 @@
+{
+    "id": "save_to_file",
+    "type": "application",
+    "value": {
+        "author": "Jane Doe",
+        "description": "A simple hello world flecs application",
+        "use": [
+            "flecs"
+        ],
+        "language": "c++"
+    }
+}
\ No newline at end of file
diff --git a/examples/cpp/31_save_to_file/src/main.cpp b/examples/cpp/31_save_to_file/src/main.cpp
new file mode 100644
index 000000000..9121bb7e1
--- /dev/null
+++ b/examples/cpp/31_save_to_file/src/main.cpp
@@ -0,0 +1,94 @@
+#include <save_to_file.h>
+#include <iostream>
+#include <fstream>
+
+#define BUFFER_SIZE (36)
+#define FILENAME "savegame.flecs"
+
+/* Component types */
+struct Position {
+    float x;
+    float y;
+};
+
+struct Velocity {
+    float x;
+    float y;
+};
+
+void save_to_file(flecs::world& world, const char *filename) {
+    flecs::reader reader(world);
+    std::fstream file(filename, std::fstream::out | std::fstream::binary);
+
+    char buffer[BUFFER_SIZE];
+    std::size_t read;
+
+    // Read from world until there is no more data, write buffer(s) to file
+    while ((read = reader.read(buffer, BUFFER_SIZE))) {
+        file.write(buffer, read);
+    }
+
+    file.close();
+}
+
+void load_from_file(flecs::world& world, const char *filename) {
+    flecs::writer writer(world);
+    std::fstream file(filename, std::fstream::in | std::fstream::binary);
+
+    char buffer[BUFFER_SIZE];
+    std::size_t read;
+
+    // Read from file until there is no more data, write buffer(s) to world
+    while ((read = file.read(buffer, BUFFER_SIZE).gcount())) {
+        writer.write(buffer, read);
+    }
+
+    file.close();
+}
+
+int main(int argc, char *argv[]) {
+    // Create world with some entities, save it to disk
+    {
+        flecs::world world(argc, argv);
+
+        flecs::component<Position>(world, "Position");
+        flecs::component<Velocity>(world, "Velocity");
+
+        flecs::entity(world, "E1")
+            .set<Position>({1, 2})
+            .set<Velocity>({1, 1});
+
+        flecs::entity(world, "E2")
+            .set<Position>({3, 4})
+            .set<Velocity>({1, 1});
+
+        // Save entities to file
+        save_to_file(world, FILENAME);
+    }
+
+    // Create new world, restore entities from disk
+    {
+        flecs::world world(argc, argv);
+
+        // Load entities from file. Note that components don't have to be 
+        // redefined, they are restored by the writer.
+        load_from_file(world, FILENAME);
+
+        // Define a system to do something with the restored entities
+        flecs::system<Position, Velocity>(world)
+            .action([](const flecs::rows& rows, 
+                flecs::column<Position> p, 
+                flecs::column<Velocity> v) 
+            {    
+                for (auto row : rows) {
+                    p[row].x += v[row].x;
+                    p[row].y += v[row].y;
+
+                    std::cout << "Moved " << rows.entity(row).name() << " to {"
+                            << p[row].x << ", " << p[row].y << "}" << std::endl;
+                }
+            });
+
+        world.progress();
+    }
+}
diff --git a/include/flecs.h b/include/flecs.h
index 39569fb6f..957deb1f1 100644
--- a/include/flecs.h
+++ b/include/flecs.h
@@ -1889,7 +1889,7 @@ ecs_reader_t ecs_snapshot_reader_init(
  */ 
 FLECS_EXPORT
 size_t ecs_reader_read(
-    void *buffer,
+    char *buffer,
     size_t size,
     ecs_reader_t *reader);
 
@@ -1920,9 +1920,9 @@ ecs_writer_t ecs_writer_init(
  * The data contained in the buffers must have been serialized with the
  * ecs_reader_read operation. If the data does not match the expected format, or
  * the data contains conflicts with the world, the operation will fail. The
- * buffers must be provided in the same order as produced by ecs_reader_read,
+ * data must be provided in the same order as produced by ecs_reader_read,
  * but the used buffer size does not have to be the same as the one used by
- * ecs_reader_read.
+ * ecs_reader_read. The buffer size must be a multiple of 4.
  * 
  * @param buffer The buffer to deserialize.
  * @param size The maximum number of bytes.
@@ -1931,10 +1931,10 @@ ecs_writer_t ecs_writer_init(
  */
 FLECS_EXPORT
 int ecs_writer_write(
-    void *buffer,
+    const char *buffer,
     size_t size,
     ecs_writer_t *writer);
-    
+
 
 ////////////////////////////////////////////////////////////////////////////////
 //// Module API
diff --git a/include/flecs/flecs.hpp b/include/flecs/flecs.hpp
index 483a5f868..f6313a17f 100644
--- a/include/flecs/flecs.hpp
+++ b/include/flecs/flecs.hpp
@@ -1417,6 +1417,48 @@ class snapshot_filter {
 };
 
 
+////////////////////////////////////////////////////////////////////////////////
+//// Reader for world/snapshot serialization
+////////////////////////////////////////////////////////////////////////////////
+
+class reader final {
+public:
+    reader(world& world) {
+        m_reader = ecs_reader_init(world.c_ptr());
+    }
+
+    reader(world& world, snapshot& snapshot) {
+        m_reader = ecs_snapshot_reader_init(world.c_ptr(), snapshot.c_ptr());
+    }
+
+    std::size_t read(char *buffer, std::size_t size) {
+        return ecs_reader_read(buffer, size, &m_reader);
+    }
+
+private:
+    ecs_reader_t m_reader;
+};
+
+
+////////////////////////////////////////////////////////////////////////////////
+//// Writer for world deserialization
+////////////////////////////////////////////////////////////////////////////////
+
+class writer final {
+public:
+    writer(world& world) {
+        m_writer = ecs_writer_init(world.c_ptr());
+    }
+
+    int write(const char *buffer, std::size_t size) {
+        return ecs_writer_write(buffer, size, &m_writer);
+    }
+
+private:
+    ecs_writer_t m_writer;
+};
+
+
 ////////////////////////////////////////////////////////////////////////////////
 //// Filter fwd declared functions
 ////////////////////////////////////////////////////////////////////////////////
diff --git a/src/reader.c b/src/reader.c
index 48cd5a60b..d0949350a 100644
--- a/src/reader.c
+++ b/src/reader.c
@@ -62,7 +62,7 @@ void ecs_component_reader_next(
 
 static
 size_t ecs_component_reader(
-    void *buffer,
+    char *buffer,
     size_t size,
     ecs_reader_t *stream)
 {
@@ -254,7 +254,7 @@ void ecs_table_reader_next(
 
 static
 size_t ecs_table_reader(
-    void *buffer,
+    char *buffer,
     size_t size,
     ecs_reader_t *stream)
 {
@@ -396,7 +396,7 @@ size_t ecs_table_reader(
 }
 
 size_t ecs_reader_read(
-    void *buffer,
+    char *buffer,
     size_t size,
     ecs_reader_t *reader)
 {
diff --git a/src/writer.c b/src/writer.c
index b260dddb5..6cf54002d 100644
--- a/src/writer.c
+++ b/src/writer.c
@@ -17,7 +17,7 @@ void ecs_name_writer_alloc(
 static
 bool ecs_name_writer_write(
     ecs_name_writer_t *writer,
-    void *buffer)
+    const char *buffer)
 {
     int32_t written = writer->len - writer->written;
     char *name_ptr = ECS_OFFSET(writer->name, writer->written);
@@ -115,7 +115,7 @@ void ecs_component_writer_next(
 
 static
 size_t ecs_component_writer(
-    void *buffer,
+    const char *buffer,
     size_t size,
     ecs_writer_t *stream)
 {
@@ -307,7 +307,7 @@ void ecs_table_writer_next(
 
 static
 size_t ecs_table_writer(
-    void *buffer,
+    const char *buffer,
     size_t size,
     ecs_writer_t *stream)
 {
@@ -433,7 +433,7 @@ size_t ecs_table_writer(
 }
 
 int ecs_writer_write(
-    void *buffer,
+    const char *buffer,
     size_t size,
     ecs_writer_t *writer)
 {
